%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')

%global _hardened_build 1

%global username OpenPrinting

Summary: A printer administration tool
Name: system-config-printer
Version: 1.5.18
Release:    1%{?dist}
License: GPL-2.0-or-later
URL: https://github.com/%{username}/%{name}
Source0: %{url}/releases/download/%{version}/%{name}-%{version}.tar.xz

Patch0001: 0001-Fix-debugprint-in-options.py-fixes-291.patch
Patch0002: 0001-udev-Fix-exit-value-when-device-is-already-handled.patch


BuildRequires: autoconf-archive
BuildRequires: cups-devel >= 1.2
BuildRequires: desktop-file-utils >= 0.2.92
BuildRequires: gcc
BuildRequires: gettext-devel
BuildRequires: git-core
BuildRequires: intltool
BuildRequires: libusb1-devel
BuildRequires: make
BuildRequires: pkgconfig(glib-2.0)
BuildRequires: python3-devel
BuildRequires: python3-setuptools
BuildRequires: systemd
BuildRequires: systemd-devel
BuildRequires: xmlto


Requires: dbus-x11
Requires: desktop-file-utils >= 0.2.92
Requires: desktop-notification-daemon
Requires: gtk3
Requires: libcanberra-gtk3
Requires: libnotify
Requires: python3-cairo
Requires: python3-dbus
Requires: python3-firewall
Requires: python3-gobject
%{?systemd_requires}
Requires: system-config-printer-libs = %{version}-%{release}

%description
system-config-printer is a graphical user interface that allows
the user to configure a CUPS print server.

%package libs
Summary: Libraries and shared code for printer administration tool
Recommends: PackageKit
Recommends: PackageKit-glib

Requires: gobject-introspection
Requires: gtk3
Requires: libnotify
Requires: python3-cups >= 1.9.60
Requires: python3-dbus
Requires: python3-gobject

Suggests: python3-smbc
BuildArch: noarch

%description libs
The common code used by both the graphical and non-graphical parts of
the configuration tool.

%package applet
Summary: Print job notification applet
Requires: %{name}-libs

%description applet
Print job notification applet.

%package udev
Summary: Rules for udev for automatic configuration of USB printers
Requires: system-config-printer-libs = %{version}-%{release}

%description udev
The udev rules and helper programs for automatically configuring USB
printers.

%prep
%autosetup -S git
sed -i 's/setup.py install --prefix=$(DESTDIR)$(prefix)/setup.py install --root $(DESTDIR) --prefix=$(prefix)/' Makefile*

%build
%configure --with-udev-rules
%make_build

%install
%make_install

%{__mkdir_p} %buildroot%{_localstatedir}/run/udev-configure-printer
touch %buildroot%{_localstatedir}/run/udev-configure-printer/usb-uris

%py_byte_compile %{__python3} %{buildroot}/%{_datadir}/system-config-printer

mv %{buildroot}%{_sysconfdir}/dbus-1/system.d/{com.redhat,org.opencloudos}.NewPrinterNotification.conf
mv %{buildroot}%{_sysconfdir}/dbus-1/system.d/{com.redhat,org.opencloudos}.PrinterDriversInstaller.conf

%find_lang system-config-printer


%files libs -f system-config-printer.lang
%doc ChangeLog NEWS ABOUT-NLS AUTHORS ChangeLog-OLD
%license COPYING
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/org.opencloudos.NewPrinterNotification.conf
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/org.opencloudos.PrinterDriversInstaller.conf
%{_datadir}/dbus-1/interfaces/*.xml
%{_datadir}/dbus-1/services/*.service
%{_bindir}/scp-dbus-service
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/__pycache__/*
%exclude %{_datadir}/%{name}/__pycache__/check-device-ids*
%exclude %{_datadir}/%{name}/__pycache__/HIG*
%exclude %{_datadir}/%{name}/__pycache__/SearchCriterion*
%exclude %{_datadir}/%{name}/__pycache__/serversettings*
%exclude %{_datadir}/%{name}/__pycache__/system-config-printer*
%exclude %{_datadir}/%{name}/__pycache__/ToolbarSearchEntry*
%exclude %{_datadir}/%{name}/__pycache__/userdefault*
%exclude %{_datadir}/%{name}/__pycache__/install-printerdriver*
%exclude %{_datadir}/%{name}/__pycache__/applet*
%{_datadir}/%{name}/asyncconn.py*
%{_datadir}/%{name}/asyncipp.py*
%{_datadir}/%{name}/asyncpk1.py*
%{_datadir}/%{name}/authconn.py*
%{_datadir}/%{name}/config.py*
%{_datadir}/%{name}/cupspk.py*
%{_datadir}/%{name}/debug.py*
%{_datadir}/%{name}/dnssdresolve.py*
%{_datadir}/%{name}/errordialogs.py*
%{_datadir}/%{name}/firewallsettings.py*
%{_datadir}/%{name}/gtkinklevel.py*
%{_datadir}/%{name}/gui.py*
%{_datadir}/%{name}/installpackage.py*
%{_datadir}/%{name}/jobviewer.py*
%{_datadir}/%{name}/killtimer.py*
%{_datadir}/%{name}/monitor.py*
%{_datadir}/%{name}/newprinter.py*
%{_datadir}/%{name}/options.py*
%{_datadir}/%{name}/optionwidgets.py*
%{_datadir}/%{name}/OpenPrintingRequest.py*
%{_datadir}/%{name}/PhysicalDevice.py*
%{_datadir}/%{name}/ppdcache.py*
%{_datadir}/%{name}/ppdippstr.py*
%{_datadir}/%{name}/ppdsloader.py*
%{_datadir}/%{name}/printerproperties.py*
%{_datadir}/%{name}/probe_printer.py*
%{_datadir}/%{name}/pysmb.py*
%{_datadir}/%{name}/scp-dbus-service.py*
%{_datadir}/%{name}/smburi.py*
%{_datadir}/%{name}/statereason.py*
%{_datadir}/%{name}/timedops.py*
%dir %{_datadir}/%{name}/__pycache__
%dir %{_datadir}/%{name}/xml
%{_datadir}/%{name}/xml/*.rng
%dir %{_sysconfdir}/cupshelpers
%config(noreplace) %{_sysconfdir}/cupshelpers/preferreddrivers.xml
%{python3_sitelib}/cupshelpers
%{python3_sitelib}/*.egg-info/

%files applet
%{_bindir}/%{name}-applet
%{_datadir}/%{name}/__pycache__/applet*
%{_datadir}/%{name}/applet.py*
%{_sysconfdir}/xdg/autostart/print-applet.desktop
%{_mandir}/man1/%{name}-applet.1*

%files udev
%{_prefix}/lib/udev/rules.d/*.rules
%{_prefix}/lib/udev/udev-*-printer
%ghost %dir %{_localstatedir}/run/udev-configure-printer
%ghost %verify(not md5 size mtime) %config(noreplace,missingok) %attr(0644,root,root) %{_localstatedir}/run/udev-configure-printer/usb-uris
%{_unitdir}/configure-printer@.service

%files
%doc ChangeLog NEWS ABOUT-NLS AUTHORS ChangeLog-OLD
%license COPYING
%{_bindir}/%{name}
%{_bindir}/install-printerdriver
%{_datadir}/%{name}/__pycache__/check-device-ids*
%{_datadir}/%{name}/__pycache__/HIG*
%{_datadir}/%{name}/__pycache__/SearchCriterion*
%{_datadir}/%{name}/__pycache__/serversettings*
%{_datadir}/%{name}/__pycache__/system-config-printer*
%{_datadir}/%{name}/__pycache__/ToolbarSearchEntry*
%{_datadir}/%{name}/__pycache__/userdefault*
%{_datadir}/%{name}/__pycache__/install-printerdriver*
%{_datadir}/%{name}/check-device-ids.py*
%{_datadir}/%{name}/HIG.py*
%{_datadir}/%{name}/SearchCriterion.py*
%{_datadir}/%{name}/serversettings.py*
%{_datadir}/%{name}/system-config-printer.py*
%{_datadir}/%{name}/ToolbarSearchEntry.py*
%{_datadir}/%{name}/userdefault.py*
%{_datadir}/%{name}/troubleshoot
%{_datadir}/%{name}/icons
%{_datadir}/%{name}/install-printerdriver.py*
%dir %{_datadir}/%{name}/xml/__pycache__
%{_datadir}/%{name}/xml/__pycache__/*
%{_datadir}/%{name}/xml/validate.py*
%dir %{_datadir}/%{name}/ui
%{_datadir}/%{name}/ui/*.ui
%{_datadir}/applications/system-config-printer.desktop
%{_datadir}/metainfo/%{name}.appdata.xml
%{_mandir}/man1/%{name}.1*

%post
%{_bindir}/rm -f /var/cache/foomatic/foomatic.pickle
exit 0

%changelog
* Tue Sep 24 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.18-1
- initial build
